
Audacious - OLD, PLEASE USE GITHUB DISCUSSIONS/ISSUES - Bug #1030

Album cover image does not display from ID3v2.2 tag

October 12, 2020 14:56 - Paul Richter

Status: Closed Start date: October 12, 2020

Priority: Minor Due date:  

Assignee:  % Done: 100%

Category: libaudtag Estimated time: 0.00 hour

Target version: 4.1   

Affects version: 4.0.4   

Description

The iTunNORM and iTunSMPB tags are added by iTunes, and both are very long strings of digits. If both of these are present and

excessively long strings (they show up in red in Kid3), audacious does not display the album artwork. The image is visible if either

value is deleted or set to a short string.

History

#1 - October 18, 2020 01:44 - Jim Turner

Can you attach a file that's got both these tags (that doesn't work)?

Thanks,

Jim

#2 - October 20, 2020 12:02 - Paul Richter

- File 13 Don_t Miss You At All.mp3 added

Sample mp3 file. It seems that the problem gets fixed (the image displays) if any of the tags get changed and saved to the file.

#3 - October 21, 2020 04:53 - Jim Turner

- File id3v24.cc.diff added

- File id3v22.cc.diff added

- File id3-common.h.diff added

- File id3-common.cc.diff added

Thanks for the example!

It appears that iTunes is saving the tags as id3v2.2 instead of the more modern id3v2.4, and apparently there's a slight difference in the format for

embedding images between the two (v2.2's "PIC" tag vs. v2.4's "APIC" tag)  See the specs here:  v2.2: https://id3.org/id3v2-00 and v2.4: 

https://id3.org/id3v2.4.0-frames, or else iTunes is just screwing with us (see here!:  

https://www.joelverhagen.com/blog/2010/12/how-itunes-uses-id3-tags)

Anyway, I patched Audacious (see attached files from src/libaudtag/id3), and it seems to work now, at least for your example.  Please try out if you

can rebuild Audacious, and see if it works for all your cases & post back here (as I don't have any other music files with the old id3v2.2 tags to test or

software to tag 'em that way)!

I'm not a developer on the Audacious team, but I've done alot of work on the Album art plugin and other stuff in my Audacious fork (send me an email

to my redmine profile email if you're interested in that - I won't discuss here on THEIR bug system), so I can't merge the patch to mainline Audacious,

but I took an interest in testing / fixing this bug.  Perhaps if it can be further tested, I can submit the patch as a pull request though.

Regards,

Jim
#4 - October 21, 2020 04:56 - Jim Turner

One other thing - I suspect that when you edit your tags, your tag-editing software may be silently converting them to id3v2.4 for you, which will cause

the image tag (now "APIC" format) to work properly.

#5 - October 22, 2020 11:18 - Paul Richter

I rebuilt with the patches and they fixed the problem. Thanks a lot.

#6 - October 23, 2020 15:38 - John Lindgren

Thank you both for looking into this. The ID3v2.2 code is somewhat unloved so I don't doubt it's a mistake in our code. I'll see about merging in a fix

based on Jim's patches.

#7 - October 23, 2020 23:02 - John Lindgren

- Category set to libaudtag

- Subject changed from Album cover image does not display if file contains iTunNORM and iTunSMPB tags to Album cover image does not display

from ID3v2.2 tag

#8 - October 23, 2020 23:48 - John Lindgren

- % Done changed from 0 to 100

- Status changed from New to Closed

https://github.com/audacious-media-player/audacious/commit/e856c927968672b04755803d78bcb6e2a99a447d

#9 - December 21, 2020 20:26 - Thomas Lange

- Target version set to 4.1

Files

13 Don_t Miss You At All.mp3 4.71 MB October 20, 2020 Paul Richter

id3-common.cc.diff 927 Bytes October 21, 2020 Jim Turner

id3-common.h.diff 558 Bytes October 21, 2020 Jim Turner

id3v22.cc.diff 622 Bytes October 21, 2020 Jim Turner

id3v24.cc.diff 623 Bytes October 21, 2020 Jim Turner
